#ifndef __GT_AUDIO_OSFUNC_H
#define __GT_AUDIO_OSFUNC_H

typedef void gt_snd_pcm_hardware ;
typedef void gt_snd_pcm_substream;
typedef void gt_snd_pcm_runtime;

u32 GT_SNDRV_PCM_RATE_5512_FUNC(void);
u32 GT_SNDRV_PCM_RATE_8000_FUNC(void);
u32 GT_SNDRV_PCM_RATE_11025_FUNC(void);
u32 GT_SNDRV_PCM_RATE_16000_FUNC(void);
u32 GT_SNDRV_PCM_RATE_22050_FUNC(void);
u32 GT_SNDRV_PCM_RATE_32000_FUNC(void);
u32 GT_SNDRV_PCM_RATE_44100_FUNC(void);
u32 GT_SNDRV_PCM_RATE_48000_FUNC(void);
u32 GT_SNDRV_PCM_RATE_64000_FUNC(void);
u32 GT_SNDRV_PCM_RATE_88200_FUNC(void);
u32 GT_SNDRV_PCM_RATE_96000_FUNC(void);
u32 GT_SNDRV_PCM_RATE_176400_FUNC(void);
u32 GT_SNDRV_PCM_RATE_192000_FUNC(void);
#define GT_SNDRV_PCM_RATE_5512	GT_SNDRV_PCM_RATE_5512_FUNC()
#define GT_SNDRV_PCM_RATE_8000	GT_SNDRV_PCM_RATE_8000_FUNC()
#define GT_SNDRV_PCM_RATE_11025	GT_SNDRV_PCM_RATE_11025_FUNC()
#define GT_SNDRV_PCM_RATE_16000	GT_SNDRV_PCM_RATE_16000_FUNC()
#define GT_SNDRV_PCM_RATE_22050	GT_SNDRV_PCM_RATE_22050_FUNC()
#define GT_SNDRV_PCM_RATE_32000	GT_SNDRV_PCM_RATE_32000_FUNC()
#define GT_SNDRV_PCM_RATE_44100	GT_SNDRV_PCM_RATE_44100_FUNC()
#define GT_SNDRV_PCM_RATE_48000	GT_SNDRV_PCM_RATE_48000_FUNC()
#define GT_SNDRV_PCM_RATE_64000	GT_SNDRV_PCM_RATE_64000_FUNC()
#define GT_SNDRV_PCM_RATE_88200	GT_SNDRV_PCM_RATE_88200_FUNC()
#define GT_SNDRV_PCM_RATE_96000	GT_SNDRV_PCM_RATE_96000_FUNC()
#define GT_SNDRV_PCM_RATE_176400	GT_SNDRV_PCM_RATE_176400_FUNC()
#define GT_SNDRV_PCM_RATE_192000	GT_SNDRV_PCM_RATE_192000_FUNC()


u32 GT_SNDRV_PCM_TRIGGER_STOP_FUNC(void);
u32 GT_SNDRV_PCM_TRIGGER_START_FUNC(void);
u32 GT_SNDRV_PCM_TRIGGER_PAUSE_PUSH_FUNC(void);
u32 GT_SNDRV_PCM_TRIGGER_PAUSE_RELEASE_FUNC(void);
u32 GT_SNDRV_PCM_TRIGGER_SUSPEND_FUNC(void);
u32 GT_SNDRV_PCM_TRIGGER_RESUME_FUNC(void);
u32 GT_SNDRV_PCM_TRIGGER_DRAIN_FUNC(void);

#define GT_SNDRV_PCM_TRIGGER_STOP             GT_SNDRV_PCM_TRIGGER_STOP_FUNC()
#define GT_SNDRV_PCM_TRIGGER_START            GT_SNDRV_PCM_TRIGGER_START_FUNC()
#define GT_SNDRV_PCM_TRIGGER_PAUSE_PUSH       GT_SNDRV_PCM_TRIGGER_PAUSE_PUSH_FUNC()
#define GT_SNDRV_PCM_TRIGGER_PAUSE_RELEASE    GT_SNDRV_PCM_TRIGGER_PAUSE_RELEASE_FUNC()
#define GT_SNDRV_PCM_TRIGGER_SUSPEND          GT_SNDRV_PCM_TRIGGER_SUSPEND_FUNC()
#define GT_SNDRV_PCM_TRIGGER_RESUME           GT_SNDRV_PCM_TRIGGER_RESUME_FUNC()
#define GT_SNDRV_PCM_TRIGGER_DRAIN            GT_SNDRV_PCM_TRIGGER_DRAIN_FUNC()

void gt_snd_pcm_period_elapsed(void *substream);
unsigned long long gt_snd_pcm_playback_avail(void *runtime);
unsigned int gt_audio_get_runtime_sample_bits(gt_snd_pcm_substream *substream);
unsigned int gt_audio_get_runtime_rate(gt_snd_pcm_substream *substream);
void gt_audio_set_runtime_hw(gt_snd_pcm_substream *substream, void *hw);
void gt_pcm_hw_set_buffer_bytes_max(gt_snd_pcm_hardware *pcm_hw, unsigned long val);
void gt_pcm_hw_set_period_bytes_max(gt_snd_pcm_hardware *pcm_hw, unsigned long val);
void gt_pcm_hw_set_period_bytes_min(gt_snd_pcm_hardware *pcm_hw, unsigned long val);

#endif