#include <linux/version.h>
#include "gtaudio_drv.h"
#include "gt_audio.h"
#include "gt_misc.h"

u32 GT_SNDRV_PCM_RATE_5512_FUNC(void)
{
	return SNDRV_PCM_RATE_5512;
}
GT_EXT_SYM(GT_SNDRV_PCM_RATE_5512_FUNC);

u32 GT_SNDRV_PCM_RATE_8000_FUNC(void)
{
	return SNDRV_PCM_RATE_8000;
}
GT_EXT_SYM(GT_SNDRV_PCM_RATE_8000_FUNC);

u32 GT_SNDRV_PCM_RATE_11025_FUNC(void)
{
	return SNDRV_PCM_RATE_11025;
}
GT_EXT_SYM(GT_SNDRV_PCM_RATE_11025_FUNC);

u32 GT_SNDRV_PCM_RATE_16000_FUNC(void)
{
	return SNDRV_PCM_RATE_16000;
}
GT_EXT_SYM(GT_SNDRV_PCM_RATE_16000_FUNC);

u32 GT_SNDRV_PCM_RATE_22050_FUNC(void)
{
	return SNDRV_PCM_RATE_22050;
}
GT_EXT_SYM(GT_SNDRV_PCM_RATE_22050_FUNC);

u32 GT_SNDRV_PCM_RATE_32000_FUNC(void)
{
	return SNDRV_PCM_RATE_32000;
}
GT_EXT_SYM(GT_SNDRV_PCM_RATE_32000_FUNC);

u32 GT_SNDRV_PCM_RATE_44100_FUNC(void)
{
	return SNDRV_PCM_RATE_44100;
}
GT_EXT_SYM(GT_SNDRV_PCM_RATE_44100_FUNC);

u32 GT_SNDRV_PCM_RATE_48000_FUNC(void)
{
	return SNDRV_PCM_RATE_48000;
}
GT_EXT_SYM(GT_SNDRV_PCM_RATE_48000_FUNC);

u32 GT_SNDRV_PCM_RATE_64000_FUNC(void)
{
	return SNDRV_PCM_RATE_64000;
}
GT_EXT_SYM(GT_SNDRV_PCM_RATE_64000_FUNC);

u32 GT_SNDRV_PCM_RATE_88200_FUNC(void)
{
	return SNDRV_PCM_RATE_88200;
}
GT_EXT_SYM(GT_SNDRV_PCM_RATE_88200_FUNC);

u32 GT_SNDRV_PCM_RATE_96000_FUNC(void)
{
	return SNDRV_PCM_RATE_96000;
}
GT_EXT_SYM(GT_SNDRV_PCM_RATE_96000_FUNC);

u32 GT_SNDRV_PCM_RATE_176400_FUNC(void)
{
	return SNDRV_PCM_RATE_176400;
}
GT_EXT_SYM(GT_SNDRV_PCM_RATE_176400_FUNC);

u32 GT_SNDRV_PCM_RATE_192000_FUNC(void)
{
	return SNDRV_PCM_RATE_192000;
}
GT_EXT_SYM(GT_SNDRV_PCM_RATE_192000_FUNC);

u32 GT_SNDRV_PCM_TRIGGER_STOP_FUNC(void)
{
	return SNDRV_PCM_TRIGGER_STOP;
}
GT_EXT_SYM(GT_SNDRV_PCM_TRIGGER_STOP_FUNC);

u32 GT_SNDRV_PCM_TRIGGER_START_FUNC(void)
{
	return SNDRV_PCM_TRIGGER_START;
}
GT_EXT_SYM(GT_SNDRV_PCM_TRIGGER_START_FUNC);

u32 GT_SNDRV_PCM_TRIGGER_PAUSE_PUSH_FUNC(void)
{
	return SNDRV_PCM_TRIGGER_PAUSE_PUSH;
}
GT_EXT_SYM(GT_SNDRV_PCM_TRIGGER_PAUSE_PUSH_FUNC);

u32 GT_SNDRV_PCM_TRIGGER_PAUSE_RELEASE_FUNC(void)
{
	return SNDRV_PCM_TRIGGER_PAUSE_RELEASE;
}
GT_EXT_SYM(GT_SNDRV_PCM_TRIGGER_PAUSE_RELEASE_FUNC);

u32 GT_SNDRV_PCM_TRIGGER_SUSPEND_FUNC(void)
{
	return SNDRV_PCM_TRIGGER_SUSPEND;
}
GT_EXT_SYM(GT_SNDRV_PCM_TRIGGER_SUSPEND_FUNC);

u32 GT_SNDRV_PCM_TRIGGER_RESUME_FUNC(void)
{
	return SNDRV_PCM_TRIGGER_RESUME;
}
GT_EXT_SYM(GT_SNDRV_PCM_TRIGGER_RESUME_FUNC);

u32 GT_SNDRV_PCM_TRIGGER_DRAIN_FUNC(void)
{
	return SNDRV_PCM_TRIGGER_DRAIN;
}
GT_EXT_SYM(GT_SNDRV_PCM_TRIGGER_DRAIN_FUNC);

void gt_snd_pcm_period_elapsed(void *substream)
{
	snd_pcm_period_elapsed(substream);
}
GT_EXT_SYM(gt_snd_pcm_period_elapsed);

unsigned long long gt_snd_pcm_playback_avail(void *substream)
{
	return snd_pcm_playback_avail(((struct snd_pcm_substream *)substream)->runtime);
}
GT_EXT_SYM(gt_snd_pcm_playback_avail);

unsigned int gt_audio_get_runtime_sample_bits(
							gt_snd_pcm_substream *substream)
{
	return ((struct snd_pcm_substream *)substream)->runtime->sample_bits;
}
GT_EXT_SYM(gt_audio_get_runtime_sample_bits);

unsigned int gt_audio_get_runtime_rate(
							gt_snd_pcm_substream *substream)
{
	return ((struct snd_pcm_substream *)substream)->runtime->rate;
}
GT_EXT_SYM(gt_audio_get_runtime_rate);

void gt_audio_set_runtime_hw(gt_snd_pcm_substream *substream, void *hw)
{
	struct snd_pcm_substream *sub = (struct snd_pcm_substream *)substream;

	memcpy(&sub->runtime->hw, hw, sizeof(struct snd_pcm_hardware));
}
GT_EXT_SYM(gt_audio_set_runtime_hw);

void gt_pcm_hw_set_buffer_bytes_max(gt_snd_pcm_hardware *pcm_hw, unsigned long val)
{
    struct snd_pcm_hardware *hw = (struct snd_pcm_hardware *)pcm_hw;
    hw->buffer_bytes_max = val;
}
GT_EXT_SYM(gt_pcm_hw_set_buffer_bytes_max);

void gt_pcm_hw_set_period_bytes_max(gt_snd_pcm_hardware *pcm_hw, unsigned long val)
{
    struct snd_pcm_hardware *hw = (struct snd_pcm_hardware *)pcm_hw;
    hw->period_bytes_max = val;
}
GT_EXT_SYM(gt_pcm_hw_set_period_bytes_max);

void gt_pcm_hw_set_period_bytes_min(gt_snd_pcm_hardware *pcm_hw, unsigned long val)
{
    struct snd_pcm_hardware *hw = (struct snd_pcm_hardware *)pcm_hw;
    hw->period_bytes_min = val;
}
GT_EXT_SYM(gt_pcm_hw_set_period_bytes_min);
