TEST_ITEM:{
	CODE="#include <asm/io.h>
	void gt_testconf_ioremap_nocache(void) {
		ioremap_nocache();
	}"
	DEFINE="GTGPU_IOREMAP_NOCACHE_PRESENT"
	VAL=""
	TYPE="fail_define"
	DEBUG="false"
}

TEST_ITEM:{
	CODE="#include <asm/io.h>
	void gt_testconf_ioremap_cache(void) {
		ioremap_cache();
	}"
	DEFINE="GTGPU_IOREMAP_CACHE_PRESENT"
	VAL=""
	TYPE="fail_define"
	DEBUG="false"
}

TEST_ITEM:{
	CODE="#include <asm/io.h>
	void gt_testconf_ioremap_wc(void) {
		ioremap_wc();
	}"
	DEFINE="GTGPU_IOREMAP_WC_PRESENT"
	VAL=""
	TYPE="fail_define"
	DEBUG="false"
}

TEST_ITEM:{
	CODE="#include <drm/drm_probe_helper.h>
	void gt_testconf_drm_probe_helper(void) {

	}"
	DEFINE="GTGPU_DRM_PROBE_HELPER_PRESENT"
	VAL=""
	TYPE="success_define"
	DEBUG="false"
}

TEST_ITEM:{
	CODE="#include <drm/drmP.h>
	void gt_testconf_drmP(void) {

	}"
	DEFINE="GTGPU_DRMP_PRESENT"
	VAL=""
	TYPE="success_define"
	DEBUG="false"
}

TEST_ITEM:{
	CODE="#include <linux/dma-buf.h>
	void gt_testconf_dma_buf_ops(void) {
		struct dma_buf_ops ops;
		ops.map = NULL;
	}"
	DEFINE="GTGPU_DMA_BUF_OPS_MAP_PRESENT"
	VAL=""
	TYPE="success_define"
	DEBUG="false"
}

TEST_ITEM:{
	CODE="#include <linux/kernel.h>
	void gt_testconf_do_exit(void) {
			do_exit(0);
	}"
	DEFINE="GTGPU_DO_EXIT_PRESENT"
	VAL=""
	TYPE="success_define"
	DEBUG="false"
	NEED_LINK="true"
}

TEST_ITEM:{
    CODE="#include <linux/compiler.h>
    #include <linux/uaccess.h>
    void gt_testaccess_ok(void) {
        access_ok(0,(char*)0,0);
    }"
    DEFINE="GTGPU_ACCESS_OK_2PARAM_PRESENT"
    VAL=""
    TYPE="fail_define"
    DEBUG="false"
}

TEST_ITEM:{
    CODE="#include <linux/mm.h>
    void gt_testvmf_insert_mixed(void) {
        vmf_insert_mixed();
    }"
    DEFINE="GTGPU_VMF_INSERT_MIXED_PRESENT"
    VAL=""
    TYPE="fail_define"
    DEBUG="false"
}

TEST_ITEM:{
    CODE="#include <linux/vmalloc.h>
    void gt_testunmap_kernel_range(void) {
        unmap_kernel_range(0,0);
    }"
    DEFINE="GTGPU_UNMAP_KERNEL_RANGE_NOPRESENT"
    VAL=""
    TYPE="fail_define"
    DEBUG="false"
    NEED_LINK="true"
}

TEST_ITEM:{
    CODE="
    void gt_testion_client_create(void) {
        ion_client_create();
    }"
    DEFINE="GTGPU_ION_CLIENT_PRESENT"
    VAL=""
    TYPE="fail_define"
    DEBUG="false"
}

TEST_ITEM:{
    CODE="#include <linux/workqueue.h>
    void gt_testconf_atrribute_warning(void) {
        flush_workqueue(system_wq);
    }"
    DEFINE="GTGPU_ATRRIBUTE_WARNING_PRESENT"
    VAL=""
    TYPE="fail_define"
    DEBUG="false"
}
